#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<inttypes.h>
#include	<string.h>
#include	<errno.h>
#include	<sys/ioctl.h>
#include	"../inc/srr.h"

#define CONFIRM(x)	{if ((x)==-1) {printf ("%s: %s\n", #x, strerror(errno));exit(-1);}}

int main (int argc, char** argv)
{
	int			i, err;
	int			irq=0, handle;
	pid_t		proxy;

	if (argc > 1)
		irq = atol (argv[1]);
	
	qnx_name_attach (0, "irqtest");
	proxy = qnx_proxy_attach (0, NULL, 0, 0);
	printf ("Attached proxy: %d\n", proxy);

	for (i=0; i<1; i++)
	{
		handle = SrrIrq_Attach (irq);
		err = errno;
		
		SrrIrq_Proxy (handle, proxy);

		if (handle < 0)
		{
			printf ("Failed: handle=%d: %s\n", handle, strerror(err));
			exit (-1);
		}
		else
			printf ("IRQ handle is %d\n", handle);

		CONFIRM(SrrIrq_Maps (handle, 0, 16));
		CONFIRM(SrrIrq_Ldregs (handle, 0, 0, 0, 0, sizeof(int32_t)));
		CONFIRM(SrrIrq_Inc (handle, 0, 0));
		CONFIRM(SrrIrq_Stregs (handle, 0, 0, 0, 0, sizeof(int32_t)));
		CONFIRM(SrrIrq_Handled (handle, 0));
	}

	for (;;)
	{
		char		data[128];
		pid_t		sender;
		
		sender = Receive (0, data, sizeof(data));
		if (sender != proxy)
		{
			printf ("Sender was: %x, but proxy was %x\n",
					sender, proxy);
		}
		else
		{
			int32_t		value;
			
			SrrIrq_Read (handle, 0, 0, sizeof(int32_t), (char*)&value);
			printf ("\rValue: %d", value);
		}
		fflush (stdout);
		
	}
	
	SrrIrq_Detach (handle);
	return (0);
}
