/*
 * This is a child process that is exec'd by its parent.  It tries to
 * find possible problems with releasing names when a parent dies with
 * an SRR name attached while the child continues to run.  The name
 * would be left attached to a dead process if the SRR module cannot
 * figure out that the parent has died.
 */

#include	<stdio.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<srr.h>

int main (int argc, char** argv)
{
	pid_t			pid;
	unsigned int	copies;
		
	setsid();
	printf ("Child started: %d\n", getpid());
	sleep (5);
	pid = SrrNameLocate (0, "name1", 0, &copies);
	if (pid != -1)
	{
		printf ("Error: Name 'name1' was held by child after parent died.\n");
	}
	else
	{
		printf ("Success: child did not hold its parent's name.\n");
	}
	return (0);
}
