/*
 * recv.c: simple program that receives a mesg and exits
 *
 * $Id: recv.c 132 2011-07-01 14:35:01Z meaton $
 */

#include <assert.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "srr.h"

int main(int argc, char* argv[])
{
	int		opt;
	pid_t	pid = 0;
	pid_t	client = 0;
	char*	name = 0;
	char	recv[BUFSIZ] = "";

	while((opt = getopt(argc, argv, "p:n:")) != -1)
	{
		switch(opt)
		{
		case 'p':
			pid = atoi(optarg);
			break;

		case 'n':
			name = optarg;
			break;

		default:
			exit(1);
		}
	}

	printf ("My pid is: %d\n", getpid());

	if(SrrReg() == -1)
	{
		printf("recv %d: InitSrr() failed: [%d] %s\n",
			getpid(), errno, strerror(errno));
		exit(1);
	}

	if(name)
	{
		if(qnx_name_attach(0, name) == -1)
		{
			printf("recv %d: qnx_name_attach(%s) failed: [%d] %s\n",
				getpid(), name, errno, strerror(errno));
			exit(1);
		}
	}

	if((client = Receive(pid, recv, BUFSIZ)) == -1)
	{
		printf("recv %d: Receive(%d) failed: [%d] %s\n",
			getpid(), pid, errno, strerror(errno));
		exit(1);
	}

	printf("recv %d: received: \"%s\"\n", getpid(), recv);
	Reply (client, "OK", 3);

	return 0;
}

