/* Deal with CONFIG_MODVERSIONS */
/* If you have problems with kernel symbol versions, uncommenting this
   might help.  It works on kernels up to 2.2.14, but fails on the 2.2.16
   that is shipped in RedHat 7.0.  Somebody messed with the /usr/include
   headers, and now there appears to be no way to include modversions into
   a module.  Go figure.  This works again with a stock 2.4.0 kernel. */

#ifndef DECLARE_MODULE_VERSION
#define __NO_VERSION__		/* define kernel version only once, here. */
#endif

#include <linux/module.h>
#include <linux/kernel.h>

#ifdef FORCE_SYMBOLS
#include "config.h"
#endif

#include <linux/version.h>
#if CONFIG_MODVERSIONS==1
#define MODVERSIONS
#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,2,16)) || defined(FORCE_SYMBOLS)
#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,4,23))
#include <linux/modversions.h>
#else
#include <config/modversions.h>
#endif
#endif
#endif

#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,4,17))
#include <linux/malloc.h>
#else
#include <linux/slab.h>
#endif

#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,26))
#include <linux/sched.h>
#include <linux/semaphore.h>
#include <linux/kthread.h>

// use the default pid namespace when finding processes
// #define find_task_by_pid(tid) find_task_by_pid_ns((tid),&init_pid_ns)
#define find_task_by_pid(tid) pid_task(find_pid_ns(tid, &init_pid_ns), PIDTYPE_PID)
#define srr_create_proc_read_entry create_proc_read_entry

// /proc namespace now starts at NULL, not at proc_root
#define PROC_ROOT	NULL
#else // Older kernel versions prior to 2.6.26
#define PROC_ROOT	&proc_root
// create_proc_info_entry was replaced by create_proc_read_entry
#define srr_create_proc_read_entry(_name,_flags,_root,_func,_null)	\
		create_proc_info_entry(_name,_flags,_root,_func)
#endif
